int getResource(char *resource, char mode)
{
	//*******************************************************************
	//***parse resource name, check security, check permissions       ***
	//*******************************************************************
	struct stat filestat; //don't make this a pointer - it wont allocate
	char *filepath;	//to help keep things straight
	int gotlist = 0;
	chopend(resource);
	
	if(resource[0] != '/') return 404;
	if(strstr(resource,"..")!=(char*)0) return 404;
	if(strstr(resource,"/./")!=(char*)0) return 404;
	if(!checkAuth(resource)) return 401;
	if(startswith(resource,"/admin/list/")
		&&strstr(resource+12,"/")==0) gotlist=1; //dont allow subdirs
	prepend(resource,wwwroot);
	filepath = resource;	//to help remember it has the wwwroot	
	
	stat(filepath, &filestat); //dont know if it exists, so cant check ret
	if(endswith(filepath, "/"))	//requesting a directory
		strcat(filepath, indexname);
	else if(S_ISDIR(filestat.st_mode))//file is a dir
		//{strcat(filepath,"/");strcat(filepath,indexname);} 
		{strcat(filepath,"/");return 301;} //so listings work right
	
	if(mode == 'x')
	{
		if(access(filepath, F_OK)) return 404;
		stat(filepath, &filestat);
		if(S_ISDIR(filestat.st_mode)) return 403; //in case of dir 
							//called 'index.html'
		if(access(filepath, X_OK)) return 403;
		else return 200;
	}
	
	if(endswith(filepath, indexname))
	{
		if(access(filepath, F_OK)) //no index.html file
		{
			//must check if directory is readable
			int len=strlen(filepath);
			while(len>=0&&filepath[len]!='/') --len;
			if(len>0) filepath[len]=0;
			else if(filepath[0]=='/') filepath[1]=0;//wwwroot="/"
			else return 400;	//must start with a '/'
			if(access(filepath, R_OK)) return 403;
			filepath[len]='/';
			return 200; //Listing
		}
		if(stat(filepath, &filestat)!=0 && !gotlist) return 500;
		//First check if "index.html" is a directory
		//If !exist, will just return last result
		//therefore must check for listing first
		if(S_ISDIR(filestat.st_mode)) return 404; 
		if(access(filepath, R_OK)) return 403;
	}
	if(access(filepath, F_OK)) 
	{
		if(gotlist)
		{
			if(endswith(filepath,"directory.gif"))
				return 200;
			chopfilename(filepath); //all else are default
			strcat(filepath,"default.gif");
			return 200;
		}
		else return 404;
	}
	if(access(filepath, R_OK)) return 403; //forbidden to anyone
	return 200;	//any normal file

}
