// CGI Environment Variables - used when calling a CGI prog
//char *SERVER_SOFTWARE = "SERVER_SOFTWARE=httpd/1.0";
//char *SERVER_NAME = "SERVER_NAME=www.dfcd.net";
//char *GATEWAY_INTERFACE = "GATEWAY_INTERFACE=CGI/1.0";
//char *SERVER_PROTOCOL = "SERVER_PROTOCOL=HTTP/1.0";
//char *SERVER_PORT = "PORT=80";
char REQUEST_METHOD[METHODMAXLEN+16];//="REQUEST_METHOD=";
//char PATH_INFO[128];
//char PATH_TRANSLATED[128];
//char SCRIPT_NAME[128];
char *QUERY_STRING;
//char REMOTE_HOST[128];
char REMOTE_ADDR[28]="REMOTE_ADDR=";
//char *AUTH_TYPE = "AUTH_TYPE=Basic";
//char REMOTE_USER[128];
//char REMOTE_IDENT[128];
char CONTENT_TYPE[CONTTYPEMAXLEN+16];//="CONTENT_TYPE=";
char CONTENT_LENGTH[CONTLENMAXLEN+16];//="CONTENT_LENGTH=";
//--------------------------
//char *cgienv[11];
char *cgienv[6];

int handleCGI(char *resource, int sock)
{
	char *filepath = resource;
	int retcode = getResource(resource,'x');
	int child_status;
	if(retcode >= 300)
	{
		errResponse(retcode, sock);
		return retcode;
	}
	else firstline(retcode,sock);
	//Now we have a file that exists, is not a dir, and has execute perms.
	//At this point we can fork, launch the prog, setup the pipes, and
	//allow the output to be sent over the socket (Prog handles headers)
	
	retcode = fork();
	if(retcode == 0)	//this is the child
	{	//note: dup uses the lowest-numbered unused descriptor
		fflush(stdout);
		dup2(sock,0);
		dup2(sock,1);
		setbuf(stdin, 0);
		setbuf(stdout, 0);
		setbuf(stderr, 0);
		execve(filepath,NULL,cgienv);
		printf("Failed to run CGI program!\n");
		exit(1);
	}
	//now sit around until the child process exits so that
	//we don't close the socket before it is done
	waitpid(retcode,&child_status,0);
	printf(" 200\n");
	return 0;
}

void LoadQueryString(char *resource)
{
	char *querystr = strstr(resource,"?"); 
		//resource contains everything after filename
        char num[8];
	if(querystr>=seekfield(resource,2)) querystr=0; //only '?' in filepath
	if(querystr != 0) //we have a CGI GET request
        {
		QUERY_STRING = (char*) malloc(sizeof(char)*(QUERYSTRMAXLEN+16));
		cgienv[4] = QUERY_STRING;
		strcpy(QUERY_STRING, "QUERY_STRING=");
		copyfield(QUERY_STRING+13, querystr+1, QUERYSTRMAXLEN);
		chopend(querystr+1); //terminate the query string
		sprintf(num,"%i",strlen(querystr+1));
		if(endswith(CONTENT_LENGTH,"=")) //dont overwrite if its a post
			strcat(CONTENT_LENGTH,num); //can't be too long a num
		querystr[0] = 0; //chop query string off resource
        }
}

void initCGIenv()
{
	cgienv[0]=REQUEST_METHOD;
	cgienv[1]=CONTENT_TYPE;
	cgienv[2]=CONTENT_LENGTH;
	cgienv[3]=REMOTE_ADDR;
	cgienv[4]=0; //must be last because sometimes 0
	cgienv[5]=0;
	strcpy(REQUEST_METHOD,"REQUEST_METHOD=");
	strcpy(CONTENT_TYPE,"CONTENT_TYPE=");
	strcpy(CONTENT_LENGTH,"CONTENT_LENGTH=");
	strcpy(REMOTE_ADDR,"REMOTE_ADDR=");
	QUERY_STRING = 0; //null pointer
}


int handlePOST(char *resource, int sock)
{
	chopend(resource);
	strcat(REQUEST_METHOD,"POST");
	return handleCGI(resource,sock);
}
