int firstline(int statuscode, int sock)
{
	char number[3*sizeof(int)+1]; //3 is max decimal digits per byte
	sprintf(number,"%i",statuscode);
	send(sock,"HTTP/1.0 ",9,0);
	send(sock,number,3,0);
	send(sock," \r\n",3,0); //no reason phrase
	return 1;
}

int sendmime(char *resource, int sock)
{
	int i;
	static char *ext[]={".html",".htm",".txt",".gif",".jpg",".jpeg",
		".bmp",".png",".css",".au",".wav",".mp3",".mid",".midi",
		".avi",".mov",".qt",".mpg",".mpeg",".vrml",".wrl",".exe",
		".zip",".gz",".rar",".tar",".pdf",""};
	static char extindex[]={0,0,1,2,3,3,4,5,6,7,8,9,10,10,
				11,12,12,13,13,14,14,15,15,15,15,15,16};
	static char *mime[]={"text/html","text/plain","image/gif",
		"image/jpeg","image/bmp","image/png","text/css",
		"audio/basic","audio/wav","audio/mpeg","audio/midi",
		"video/x-msvideo","video/quicktime","video/mpeg",
		"model/vrml","application/binary","application/pdf"};
	for(i=0;ext[i][0]!=0;++i)
	{
		if(endswith(resource,ext[i]))
		{
			send(sock,mime[extindex[i]],strlen(mime[extindex[i]]),0);
			return 1;
		}
	}
	send(sock,"text/plain",10,0);
	return 0;
}


int handleHEAD(char *resource, int sock)
{
	//if simple request, give them a head since they explicitly request it
	int retcode = getResource(resource,'r');
	firstline(retcode, sock);
	if(retcode==401) //unauthorized
	{
		send(sock,"WWW-Authenticate: Basic realm=\"",31,0);
		send(sock, realm, strlen(realm),0);
		send(sock, "\"\r\n",3,0);
	}
	if(retcode==301) //moved permanently
	{
		send(sock,"Location: ",10,0);
		send(sock,resource+strlen(wwwroot),
			strlen(resource)-strlen(wwwroot),0);
		send(sock,"\r\n",2,0);
	}
	//send(sock,"Server: httpd\r\nContent-Type: ",29,0);
	send(sock,"Server: ",8,0);
	send(sock,servername,strlen(servername),0);
	send(sock,"\r\nContent-Type: ",16,0);
	
	if(retcode >=300) 
		send(sock,"text/html",9,0);
	else sendmime(resource,sock);
	send(sock,"\r\n\r\n",4,0);	//end header list
	
	return retcode;
}
