#include <stdio.h>
#include <string.h>
#include <unistd.h>		//access()
#include <sys/types.h>  //socket constants
#include <sys/socket.h> //socket functions
#include <sys/stat.h>   //test if dir
#include <sys/wait.h>   //waitpid
#include <fcntl.h>
#include <errno.h>
#include <netinet/in.h> //addr struct
#include <dirent.h>

#define WWWROOTMAXLEN 256
#define MAXCONNECTS 128
#define REQUESTMAXLEN 2048
#define COOKIEMAXLEN 128
#define CONTTYPEMAXLEN 32
#define CONTLENMAXLEN 16	//can segfault if this is lower than 5
#define METHODMAXLEN 16
#define QUERYSTRMAXLEN	2048	//this is dynamicly allocated
#define REALMMAXLEN 128
int simple; //used to omit header if it is a simple request
int quiet;	//when set, error bodies are not printed

#include "images.c"
#include "util.c"
#include "b64decode.c"
#include "err.c"
#include "sig.c"
#include "log.c"
#include "list.c"
#include "auth.c"
#include "access.c"
#include "cgi.c"
#include "head.c"
#include "get.c"
#include "request.c"

int handleCONN(int sock,struct sockaddr_in client)
{
	struct in_addr client_ip;
	char *buf = (char*) malloc(sizeof(char)*
			(strlen(wwwroot)+REQUESTMAXLEN+128) );
		//"index.html" or "directory.gif" may be added here
	memcpy(&client_ip, &client.sin_addr.s_addr, 4);
	writeLog("ip",(char *)inet_ntoa(client_ip));
	writeLog("ip"," ");
	initCGIenv();
	strcat(REMOTE_ADDR,(char *)inet_ntoa(client_ip));
	headrecv(sock,buf,REQUESTMAXLEN);//guarantees at least a null string
	parseRequest(buf,sock);		//handles all processing
	free(buf);
	//shutdown(sock,2);	//this is needed or browser stalls
	shutdown(sock,0);
	close(sock);
	exit(0);
}

int main(int argc, char *argv[])
{
	int i=1,sock,master,addrlen,retcode,child_status;
	struct sockaddr_in addr;
	FILE* conf;
	char *wwwroot_conf = "/etc/httpd.conf";
	//cookie[0]=0;realm[0]=0;
	//quiet=0;simple=0;
	if(!siginit()) err("signal");
	//----------- INIT INPUT ----------------
	if(argc>2) err("Usage: httpd (<port>)");
	if(argc==2)
	{
		if(isInt(argv[1]))	
			sock=atoi(argv[1]);
		else err("Usage: httpd (<port>)");
	}
	else sock=80;	//sock is used for two purposes
	
	if(access(wwwroot_conf, F_OK) || access(wwwroot_conf, R_OK))
		wwwroot=(char*)getenv("PWD");	//env vars are saved at init
	else	
	{
		wwwroot = (char*)malloc(sizeof(char)*WWWROOTMAXLEN);
		conf = fopen(wwwroot_conf, "r");	
		fgets(wwwroot, WWWROOTMAXLEN, conf);
		fclose(conf);
		chopend(wwwroot);
	}
	if(wwwroot==0) 
		err("No PWD env-var");
	if(strlen(wwwroot)>WWWROOTMAXLEN-1) 
		err("WWWROOT path string too long!");
	//---------------------------------------
	
	printf("httpd serving %s\n",wwwroot);
	
	master = socket(AF_INET,SOCK_STREAM,0);
	if(!master) err("socket");
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(sock);
	
	if(bind(master,(struct sockaddr *)&addr,sizeof(addr))) err("bind");
	if(listen(master,MAXCONNECTS)) err("listen");

	while(1)	//main program loop
	{
	sock = accept(master,(struct sockaddr *)&addr,&addrlen);
	if(sock==-1) fprintf(stderr,"Accept Error: %i\n",errno);
	retcode = fork();
	if(retcode==0) handleCONN(sock, addr); //this is the child
	close(sock);
	}
}

