
int parseRequestHeaders(char *line)
{
	//*******************************************************************
	//***looks at all the lines after the first in the request        ***
	//*******************************************************************
	while(line[0]!=0)	//probably should be 10||13
	{
		line = nextline(line);
		lowercase(line);	//makes first field lowercase
		if(startswith(line,"authorization:"))
			{copyline(cookie,seekfield(line,3), COOKIEMAXLEN);}
			//this is field 3 because format is:
			//Authorization: Basic <base64 user-pass>
		else if(startswith(line,"from:"))
			{}//{writeLogLine("from", seekfield(line,2));}
		else if(startswith(line,"if-modified-since:"))
			{}	//call a function to check resource
		else if(startswith(line,"referer:"))
			{}//{writeLogLine("referer", seekfield(line,2));}
		else if(startswith(line,"user-agent:"))
			{}//{writeLogLine("user-agent",seekfield(line,2));}
		else if(startswith(line,"content-length:"))
			{
				strcpy(CONTENT_LENGTH,"CONTENT_LENGTH=");
				copyline(CONTENT_LENGTH+15,seekfield(line,2),CONTLENMAXLEN);
			}
		else if(startswith(line,"content-type:"))
			{copyline(CONTENT_TYPE+13,seekfield(line,2),CONTTYPEMAXLEN);}
	}
	return 1;
}

char* convertEscapes(char *r)
{
	char c=1;
	int i=0,j=0;
	while(c!='?'&&c!=' '&&c!=10&&c!=13&&c!='\t'&&c!=0)
	{
		c = r[i]; //just used to check for end
		if(c=='%')
		{
			if(!isHex(r[i+1])||!isHex(r[i+2]))
				return 0;
			r[i]=toNum(r[i+1])*16+toNum(r[i+2]);
			if(r[i]==' ') r[i]='\\';
			j=i+1;
			while(r[j+1]) {r[j]=r[j+2];j++;}
		}
		++i;
	}
	return r;
}


int parseRequest(char *request, int sock)
{
	//*******************************************************************
	//***a request always stays in the same buffer that was created   ***
	//***in main, but it is manipulated from a full request, into a   ***
	//***resource (second field of request), then into a filepath     ***
	//*******************************************************************
	char *resource;
	cookie[0]=0;realm[0]=0;quiet=0;	//clear any global data from last time
	cookie_decoded = 0;
	//initCGIenv(); //moved to handleCONN so that IP gets stored
	//log the full request exactly as found
	//writeLog("request",request);
	request=seekfield(request,1); //chop any leading whitespace
	writeLogLine("Request",request);
	//check if simple request or full request
	if(startswith(seekfield(request,3),"HTTP/"))
		simple = 0;
	else simple = 1;
	parseRequestHeaders(request); //won't affect first line
	
	resource = convertEscapes(seekfield(request,2));
	if(resource == 0) {errResponse(400,sock);return 0;}
	LoadQueryString(resource);
	
	if(startswith(request,"GET"))
		handleGET(resource, sock);
	else if(startswith(request,"HEAD"))
		handleHEAD(resource, sock);
	else if(startswith(request,"POST"))
		handlePOST(resource, sock);
	else errResponse(400,sock);	//bad request
	if(QUERY_STRING != 0) free(QUERY_STRING);
	return 1;
}

int headrecv(int sock, char *buf, int maxlen)
{		//should add support for http/0.9
	//puts null-terminated string for the head in buf
	//and returns strlen of this string
	int c,ret;
	char x[2];
	int state = 0;
	for(c=0;c<maxlen-1;++c)	// maxlen-1 for null
	{
		ret=recv(sock,x,1,0);
		if(ret==1) buf[c]=x[0];	
		else {buf[c]=0;return c;}
		if(x[0]==10) state+=10;
		else if(x[0]==13) state+=13;
		else state = 0;
		if(state==10||state==13)
			if(strstr(buf,"HTTP/")==0||strstr(buf,"HTTP/0.")!=0)
				{buf[c]=0;return c;}
		if(state==20||state==26||state==46) // finds 2 newlines
		{buf[c+1]=0;return c+1;}
	}
}
