//--------------GLOBAL DATA---------------------------------------
	static const char *err501 = 
		"<html><body><h1>501 Error: Not Implemented</h1></body></html>";
	static const char *err500 = 
	  "<html><body><h1>500 Error: Internal Server Error</h1></body></html>";
	static const char *err301 = 
	      "<html><body><h1>301 Error: Moved Permanently</h1></body></html>";
	static const char *err400 = 
		"<html><body><h1>400 Error: Bad Request</h1></body></html>";
	static const char *err401 = 
		"<html><body><h1>401 Error: Unauthorized</h1></body></html>";
	static const char *err403  =
		"<html><body><h1>403 Error: Forbidden</h1></body></html>";
	static const char *err404  = 
		"<html><body><h1>404 Error: File Not Found</h1></body></html>";

	static char *wwwroot; 
	static const char *indexname   = "index.html";
	static const char *servername = "httpd";
	//just make sure the sum of these last two lengths does not exceed 512
	
	static const char *listheader = "<html><body><hr>";
	static const char *listfooter = "<hr></body></html>";
//-------------------------------------------------------------------

int isInt(char *str)
{
	if(str[0]==0) return 0;
	if(strlen(str)>5) return 0;
	while(str[0]!=0) {if(str[0]>'9'||str[0]<'0') return 0;++str;}
	return 1;
}

int isHex(char c)
{
	if(c>='0'&&c<='9') return 1;
	if(c>='A'&&c<='F') return 1;
	return 0;
}

int toNum(char c)
{
	if(c>='0'&&c<='9') return c-'0';
	if(c>='A'&&c<='F') return c-'A'+10;
	return -1;
}
	
long strtol(char *str)    
{
	long result = 0;
	int negative=0;
	while (*str == ' ' || *str == '\t') str++;
	if (*str == '+') str++;
	else if (*str == '-') {negative = 1;str++;}
	while (*str >= '0' && *str <= '9')
		result = (result*10)+(*str++ - '0');
	return negative ? -result : result;
}

int strmcpy(char *dest, char *src, int maxlen)
{
	int i;
	for(i=0;i<maxlen-1&&src[i]!=0;++i)
		dest[i]=src[i];
	dest[i]=0;	//have to guarantee null terminated
	if(i==maxlen-1&&src[i]!=0) return -1;
	return 0;
}

int strmcat(char *dest, char *src, int maxlen)
{	//maxlen refers to the total chars in dest, not how many to add
	int i;
	int j=strlen(dest);
	for(i=0;(i+j)<maxlen-1&&src[i]!=0;++i)	//requires lazy evaluation
		dest[i+j]=src[i];
	dest[i+j]=0;
	if((i+j)==maxlen-1&&src[i]!=0) return -1;
	return 0;
}
	
int err(char *msg) {fprintf(stderr,"Error: %s\n",msg);exit(1);}

void lowercase(char *str)
{
	int i=0;
	while(str[i]!=':' && str[i]!=0 && str[i]!=10 && str[i]!=13)
	{
		if(str[i]>='A' && str[i]<='Z')
			str[i] += 32;
		++i;
	}
}

char* nextline(char *str)
{
	int i=0;
	while(str[i]!=10 && str[i]!=13 && str[i]!=0) ++i;
	if(str[i]==0) return str+i;
	if(str[i+1]==10 || str[i+1]==13)
		if(str[i+1]!=str[i]) //got another NL type, is it different?
			return str+i+2;
	return str+i+1;
}

void copyfield(char *dest, char *src, int max)
{
	int i;
	char c=1;
	for(i=0;c!=10&&c!=13&&c!=0&&c!=' '&&c!='\t'&&i<max;++i)
	{
		c = src[i];
		dest[i]=c;
	}
	dest[i-1]=0;	
}

void copyline(char *dest, char *src, int max)
{
	int i;
	char c=1;
	for(i=0;c!=10 && c!=13 && c!=0 && i<max;++i)
	{
		c = src[i];
	        dest[i]=c;
	}
	dest[i-1]=0;	//old version: dest[i]=0
}


char* seekfield(char *str, int field)
{
	#define onDelim str[i]==' '||str[i]=='\t'
	int i=0,f=1;
	while(onDelim) ++i;
	for(;f<field;++f)
		for(;str[i]!=0;++i)
			if(onDelim) 
			{		
				while(onDelim) ++i;
				break;
			} 
	return str+i;
}

char* chopfilename(char *str)
{
        int i = strlen(str);
	while(str[i]!='/'&&i>=0) --i; //guaranteed to have one
	str[i+1]=0;
	return str;
}

char* chopend(char *str) //inline because only used once
{
	int i;
	for(i=0;;++i)
	{
		if(str[i]==10) break;
		if(str[i]==13) break;
		if(str[i]=='\t') break;
		if(str[i]==' ') break; //might need to change
		if(str[i]==0) break;
		if(str[i]=='\\') str[i]=' '; //resource had a space
	}
	str[i]=0;	//end on first whitespace
	return str;
}

int startswith(const char *str, const char *token)
{	//this will return true if token is a null string
	int i;
	for(i=0;token[i]!=0;++i)
		if(str[i]!=token[i]) return 0;
	return 1;
}

int endswith(const char *str, const char *token)
{
	int i,len=strlen(token);
	int start=strlen(str)-len;
	if(start<0) return 0;
	for(i=0;i<len;++i)
		if(str[start+i]!=token[i]) return 0;
	return 1;
}

char* prepend(char *str, const char *token)
{
	int i,shift=strlen(token);
	for(i=strlen(str);i>=0;--i)
		str[i+shift]=str[i];
	strncpy(str,token,shift);
	return str;
}

void shiftleft(char *str, int n)
{
	//shifts str so that str[n] is at front
	int i;
	if(strlen(str)<n)
	{
		str[0]=0;
		return;
	}
	for(i=0;str[i+n-1]!=0;++i)
		str[i]=str[i+n];
}
